<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>JavaOperations xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/codegen/xtend/JavaOperations.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2014 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.codegen.xtend;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> com.google.common.base.Objects;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> java.util.Collection;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.codegen.Constants;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.codegen.utils.JavaGenUtils;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.codegen.utils.Modifier;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.codegen.xtend.JavaDocumentation;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.codegen.xtend.JavaParameter;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.Default;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.Native;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.DataType;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Parameter;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterDirectionKind;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.profile.standard.Create;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtend2.lib.StringConcatenation;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.CollectionLiterals;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.xtext.xbase.lib.Conversions;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  @SuppressWarnings(<span class="jxr_string">"all"</span>)
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/codegen/xtend/JavaOperations.html">JavaOperations</a> {
<a class="jxr_linenumber" name="L41" href="#L41">41</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence javaOperationImplementation(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L43" href="#L43">43</a>      String _body = GenUtils.getBody(operation, Constants.supportedLanguages);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>      _builder.append(_body, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L45" href="#L45">45</a>      _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L46" href="#L46">46</a>      <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>    }
<a class="jxr_linenumber" name="L48" href="#L48">48</a>    
<a class="jxr_linenumber" name="L49" href="#L49">49</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String javaReturnSpec(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L50" href="#L50">50</a>      String _xifexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>      <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>      Type _type = operation.getType();
<a class="jxr_linenumber" name="L53" href="#L53">53</a>      <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_type, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L54" href="#L54">54</a>      <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>        _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>        <strong class="jxr_keyword">boolean</strong> _isConstructor = JavaOperations.isConstructor(operation);
<a class="jxr_linenumber" name="L58" href="#L58">58</a>        _or = _isConstructor;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>      }
<a class="jxr_linenumber" name="L60" href="#L60">60</a>      <strong class="jxr_keyword">if</strong> (_or) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>        _xifexpression = JavaOperations.constructorOrVoid(operation);
<a class="jxr_linenumber" name="L62" href="#L62">62</a>      } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>        Type _type_1 = operation.getType();
<a class="jxr_linenumber" name="L64" href="#L64">64</a>        Element _owner = operation.getOwner();
<a class="jxr_linenumber" name="L65" href="#L65">65</a>        String _javaQualifiedName = JavaGenUtils.javaQualifiedName(_type_1, _owner);
<a class="jxr_linenumber" name="L66" href="#L66">66</a>        Parameter _returnParameter = JavaOperations.returnParameter(operation);
<a class="jxr_linenumber" name="L67" href="#L67">67</a>        String _modArray = Modifier.modArray(_returnParameter);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>        String _plus = (_javaQualifiedName + _modArray);
<a class="jxr_linenumber" name="L69" href="#L69">69</a>        _xifexpression = (_plus + <span class="jxr_string">" "</span>);
<a class="jxr_linenumber" name="L70" href="#L70">70</a>      }
<a class="jxr_linenumber" name="L71" href="#L71">71</a>      <strong class="jxr_keyword">return</strong> _xifexpression;
<a class="jxr_linenumber" name="L72" href="#L72">72</a>    }
<a class="jxr_linenumber" name="L73" href="#L73">73</a>    
<a class="jxr_linenumber" name="L74" href="#L74">74</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Parameter returnParameter(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>      EList&lt;Parameter&gt; _returnResult = operation.returnResult();
<a class="jxr_linenumber" name="L76" href="#L76">76</a>      <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">final</strong> Parameter parameter : _returnResult) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>        <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L78" href="#L78">78</a>        ParameterDirectionKind _direction = parameter.getDirection();
<a class="jxr_linenumber" name="L79" href="#L79">79</a>        <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_direction, ParameterDirectionKind.RETURN_LITERAL);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>        <strong class="jxr_keyword">if</strong> (!_equals) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>          _and = false;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>        } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>          Type _type = parameter.getType();
<a class="jxr_linenumber" name="L84" href="#L84">84</a>          Type _type_1 = operation.getType();
<a class="jxr_linenumber" name="L85" href="#L85">85</a>          <strong class="jxr_keyword">boolean</strong> _equals_1 = Objects.equal(_type, _type_1);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>          _and = _equals_1;
<a class="jxr_linenumber" name="L87" href="#L87">87</a>        }
<a class="jxr_linenumber" name="L88" href="#L88">88</a>        <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>          <strong class="jxr_keyword">return</strong> parameter;
<a class="jxr_linenumber" name="L90" href="#L90">90</a>        }
<a class="jxr_linenumber" name="L91" href="#L91">91</a>      }
<a class="jxr_linenumber" name="L92" href="#L92">92</a>      <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L93" href="#L93">93</a>    }
<a class="jxr_linenumber" name="L94" href="#L94">94</a>    
<a class="jxr_linenumber" name="L95" href="#L95">95</a>    <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence throwss(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>      StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L97" href="#L97">97</a>      {
<a class="jxr_linenumber" name="L98" href="#L98">98</a>        EList&lt;Type&gt; _raisedExceptions = operation.getRaisedExceptions();
<a class="jxr_linenumber" name="L99" href="#L99">99</a>        <strong class="jxr_keyword">int</strong> _length = ((Object[])Conversions.unwrapArray(_raisedExceptions, Object.<strong class="jxr_keyword">class</strong>)).length;
<a class="jxr_linenumber" name="L100" href="#L100">100</a>       <strong class="jxr_keyword">boolean</strong> _greaterThan = (_length &gt; 0);
<a class="jxr_linenumber" name="L101" href="#L101">101</a>       <strong class="jxr_keyword">if</strong> (_greaterThan) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a>         _builder.append(<span class="jxr_string">"throws "</span>);
<a class="jxr_linenumber" name="L103" href="#L103">103</a>         {
<a class="jxr_linenumber" name="L104" href="#L104">104</a>           EList&lt;Type&gt; _raisedExceptions_1 = operation.getRaisedExceptions();
<a class="jxr_linenumber" name="L105" href="#L105">105</a>           <strong class="jxr_keyword">boolean</strong> _hasElements = false;
<a class="jxr_linenumber" name="L106" href="#L106">106</a>           <strong class="jxr_keyword">for</strong>(<strong class="jxr_keyword">final</strong> Type re : _raisedExceptions_1) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a>             <strong class="jxr_keyword">if</strong> (!_hasElements) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a>               _hasElements = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L109" href="#L109">109</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L110" href="#L110">110</a>               _builder.appendImmediate(<span class="jxr_string">","</span>, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L111" href="#L111">111</a>             }
<a class="jxr_linenumber" name="L112" href="#L112">112</a>             String _name = re.getName();
<a class="jxr_linenumber" name="L113" href="#L113">113</a>             _builder.append(_name, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L114" href="#L114">114</a>           }
<a class="jxr_linenumber" name="L115" href="#L115">115</a>         }
<a class="jxr_linenumber" name="L116" href="#L116">116</a>         _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L117" href="#L117">117</a>       }
<a class="jxr_linenumber" name="L118" href="#L118">118</a>     }
<a class="jxr_linenumber" name="L119" href="#L119">119</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L120" href="#L120">120</a>   }
<a class="jxr_linenumber" name="L121" href="#L121">121</a>   
<a class="jxr_linenumber" name="L122" href="#L122">122</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String constructorOrVoid(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a>     String _xifexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L124" href="#L124">124</a>     <strong class="jxr_keyword">boolean</strong> _isConstructor = JavaOperations.isConstructor(operation);
<a class="jxr_linenumber" name="L125" href="#L125">125</a>     <strong class="jxr_keyword">if</strong> (_isConstructor) {
<a class="jxr_linenumber" name="L126" href="#L126">126</a>       _xifexpression = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L127" href="#L127">127</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L128" href="#L128">128</a>       _xifexpression = <span class="jxr_string">"void "</span>;
<a class="jxr_linenumber" name="L129" href="#L129">129</a>     }
<a class="jxr_linenumber" name="L130" href="#L130">130</a>     <strong class="jxr_keyword">return</strong> _xifexpression;
<a class="jxr_linenumber" name="L131" href="#L131">131</a>   }
<a class="jxr_linenumber" name="L132" href="#L132">132</a>   
<a class="jxr_linenumber" name="L133" href="#L133">133</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isConstructor(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L134" href="#L134">134</a>     <strong class="jxr_keyword">return</strong> GenUtils.hasStereotype(operation, Create.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L135" href="#L135">135</a>   }
<a class="jxr_linenumber" name="L136" href="#L136">136</a>   
<a class="jxr_linenumber" name="L137" href="#L137">137</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Collection&lt;Operation&gt; getOwnedOperations(<strong class="jxr_keyword">final</strong> Classifier cl) {
<a class="jxr_linenumber" name="L138" href="#L138">138</a>     Collection&lt;Operation&gt; _xblockexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L139" href="#L139">139</a>     {
<a class="jxr_linenumber" name="L140" href="#L140">140</a>       <strong class="jxr_keyword">final</strong> EList&lt;Operation&gt; operations = JavaOperations.getOwnedOperationsWNull(cl);
<a class="jxr_linenumber" name="L141" href="#L141">141</a>       Collection&lt;Operation&gt; _xifexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L142" href="#L142">142</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(operations, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L143" href="#L143">143</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a>         _xifexpression = CollectionLiterals.&lt;Operation&gt;emptySet();
<a class="jxr_linenumber" name="L145" href="#L145">145</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L146" href="#L146">146</a>         _xifexpression = operations;
<a class="jxr_linenumber" name="L147" href="#L147">147</a>       }
<a class="jxr_linenumber" name="L148" href="#L148">148</a>       _xblockexpression = _xifexpression;
<a class="jxr_linenumber" name="L149" href="#L149">149</a>     }
<a class="jxr_linenumber" name="L150" href="#L150">150</a>     <strong class="jxr_keyword">return</strong> _xblockexpression;
<a class="jxr_linenumber" name="L151" href="#L151">151</a>   }
<a class="jxr_linenumber" name="L152" href="#L152">152</a>   
<a class="jxr_linenumber" name="L153" href="#L153">153</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> EList&lt;Operation&gt; getOwnedOperationsWNull(<strong class="jxr_keyword">final</strong> Classifier cl) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a>     EList&lt;Operation&gt; _xifexpression = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L155" href="#L155">155</a>     <strong class="jxr_keyword">if</strong> ((cl instanceof org.eclipse.uml2.uml.Class)) {
<a class="jxr_linenumber" name="L156" href="#L156">156</a>       _xifexpression = ((org.eclipse.uml2.uml.Class) cl).getOwnedOperations();
<a class="jxr_linenumber" name="L157" href="#L157">157</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L158" href="#L158">158</a>       EList&lt;Operation&gt; _xifexpression_1 = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L159" href="#L159">159</a>       <strong class="jxr_keyword">if</strong> ((cl instanceof DataType)) {
<a class="jxr_linenumber" name="L160" href="#L160">160</a>         _xifexpression_1 = ((DataType) cl).getOwnedOperations();
<a class="jxr_linenumber" name="L161" href="#L161">161</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L162" href="#L162">162</a>         EList&lt;Operation&gt; _xifexpression_2 = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L163" href="#L163">163</a>         <strong class="jxr_keyword">if</strong> ((cl instanceof Interface)) {
<a class="jxr_linenumber" name="L164" href="#L164">164</a>           _xifexpression_2 = ((Interface) cl).getOwnedOperations();
<a class="jxr_linenumber" name="L165" href="#L165">165</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L166" href="#L166">166</a>           _xifexpression_2 = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L167" href="#L167">167</a>         }
<a class="jxr_linenumber" name="L168" href="#L168">168</a>         _xifexpression_1 = _xifexpression_2;
<a class="jxr_linenumber" name="L169" href="#L169">169</a>       }
<a class="jxr_linenumber" name="L170" href="#L170">170</a>       _xifexpression = _xifexpression_1;
<a class="jxr_linenumber" name="L171" href="#L171">171</a>     }
<a class="jxr_linenumber" name="L172" href="#L172">172</a>     <strong class="jxr_keyword">return</strong> _xifexpression;
<a class="jxr_linenumber" name="L173" href="#L173">173</a>   }
<a class="jxr_linenumber" name="L174" href="#L174">174</a>   
<a class="jxr_linenumber" name="L175" href="#L175">175</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> CharSequence javaOperationDeclaration(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L176" href="#L176">176</a>     StringConcatenation _builder = <strong class="jxr_keyword">new</strong> StringConcatenation();
<a class="jxr_linenumber" name="L177" href="#L177">177</a>     CharSequence _javaOperationDoc = JavaDocumentation.javaOperationDoc(operation);
<a class="jxr_linenumber" name="L178" href="#L178">178</a>     _builder.append(_javaOperationDoc, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L179" href="#L179">179</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L180" href="#L180">180</a>     String _methodModifiers = Modifier.methodModifiers(operation);
<a class="jxr_linenumber" name="L181" href="#L181">181</a>     _builder.append(_methodModifiers, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L182" href="#L182">182</a>     String _javaReturnSpec = JavaOperations.javaReturnSpec(operation);
<a class="jxr_linenumber" name="L183" href="#L183">183</a>     _builder.append(_javaReturnSpec, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L184" href="#L184">184</a>     String _name = operation.getName();
<a class="jxr_linenumber" name="L185" href="#L185">185</a>     _builder.append(_name, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L186" href="#L186">186</a>     _builder.append(<span class="jxr_string">"("</span>);
<a class="jxr_linenumber" name="L187" href="#L187">187</a>     CharSequence _javaOperationParameters = JavaParameter.javaOperationParameters(operation);
<a class="jxr_linenumber" name="L188" href="#L188">188</a>     _builder.append(_javaOperationParameters, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L189" href="#L189">189</a>     _builder.append(<span class="jxr_string">") "</span>);
<a class="jxr_linenumber" name="L190" href="#L190">190</a>     CharSequence _throwss = JavaOperations.throwss(operation);
<a class="jxr_linenumber" name="L191" href="#L191">191</a>     _builder.append(_throwss, <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L192" href="#L192">192</a>     {
<a class="jxr_linenumber" name="L193" href="#L193">193</a>       <strong class="jxr_keyword">boolean</strong> _mustGenerateBody = JavaOperations.mustGenerateBody(operation);
<a class="jxr_linenumber" name="L194" href="#L194">194</a>       <strong class="jxr_keyword">if</strong> (_mustGenerateBody) {
<a class="jxr_linenumber" name="L195" href="#L195">195</a>         _builder.append(<span class="jxr_string">"{"</span>);
<a class="jxr_linenumber" name="L196" href="#L196">196</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L197" href="#L197">197</a>         _builder.append(<span class="jxr_string">";"</span>);
<a class="jxr_linenumber" name="L198" href="#L198">198</a>       }
<a class="jxr_linenumber" name="L199" href="#L199">199</a>     }
<a class="jxr_linenumber" name="L200" href="#L200">200</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L201" href="#L201">201</a>     _builder.append(<span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L202" href="#L202">202</a>     {
<a class="jxr_linenumber" name="L203" href="#L203">203</a>       <strong class="jxr_keyword">boolean</strong> _mustGenerateBody_1 = JavaOperations.mustGenerateBody(operation);
<a class="jxr_linenumber" name="L204" href="#L204">204</a>       <strong class="jxr_keyword">if</strong> (_mustGenerateBody_1) {
<a class="jxr_linenumber" name="L205" href="#L205">205</a>         CharSequence _javaOperationImplementation = JavaOperations.javaOperationImplementation(operation);
<a class="jxr_linenumber" name="L206" href="#L206">206</a>         _builder.append(_javaOperationImplementation, <span class="jxr_string">"\t"</span>);
<a class="jxr_linenumber" name="L207" href="#L207">207</a>       }
<a class="jxr_linenumber" name="L208" href="#L208">208</a>     }
<a class="jxr_linenumber" name="L209" href="#L209">209</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L210" href="#L210">210</a>     {
<a class="jxr_linenumber" name="L211" href="#L211">211</a>       <strong class="jxr_keyword">boolean</strong> _mustGenerateBody_2 = JavaOperations.mustGenerateBody(operation);
<a class="jxr_linenumber" name="L212" href="#L212">212</a>       <strong class="jxr_keyword">if</strong> (_mustGenerateBody_2) {
<a class="jxr_linenumber" name="L213" href="#L213">213</a>         _builder.append(<span class="jxr_string">"}"</span>);
<a class="jxr_linenumber" name="L214" href="#L214">214</a>       }
<a class="jxr_linenumber" name="L215" href="#L215">215</a>     }
<a class="jxr_linenumber" name="L216" href="#L216">216</a>     _builder.newLineIfNotEmpty();
<a class="jxr_linenumber" name="L217" href="#L217">217</a>     <strong class="jxr_keyword">return</strong> _builder;
<a class="jxr_linenumber" name="L218" href="#L218">218</a>   }
<a class="jxr_linenumber" name="L219" href="#L219">219</a>   
<a class="jxr_linenumber" name="L220" href="#L220">220</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isAbstract(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L221" href="#L221">221</a>     <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L222" href="#L222">222</a>     <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L223" href="#L223">223</a>     <strong class="jxr_keyword">boolean</strong> _and_1 = false;
<a class="jxr_linenumber" name="L224" href="#L224">224</a>     <strong class="jxr_keyword">boolean</strong> _isAbstract = operation.isAbstract();
<a class="jxr_linenumber" name="L225" href="#L225">225</a>     <strong class="jxr_keyword">if</strong> (!_isAbstract) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a>       _and_1 = false;
<a class="jxr_linenumber" name="L227" href="#L227">227</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L228" href="#L228">228</a>       Element _owner = operation.getOwner();
<a class="jxr_linenumber" name="L229" href="#L229">229</a>       _and_1 = (_owner instanceof Classifier);
<a class="jxr_linenumber" name="L230" href="#L230">230</a>     }
<a class="jxr_linenumber" name="L231" href="#L231">231</a>     <strong class="jxr_keyword">if</strong> (!_and_1) {
<a class="jxr_linenumber" name="L232" href="#L232">232</a>       _and = false;
<a class="jxr_linenumber" name="L233" href="#L233">233</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L234" href="#L234">234</a>       <strong class="jxr_keyword">boolean</strong> _or_1 = false;
<a class="jxr_linenumber" name="L235" href="#L235">235</a>       Element _owner_1 = operation.getOwner();
<a class="jxr_linenumber" name="L236" href="#L236">236</a>       <strong class="jxr_keyword">boolean</strong> _isAbstract_1 = ((Classifier) _owner_1).isAbstract();
<a class="jxr_linenumber" name="L237" href="#L237">237</a>       <strong class="jxr_keyword">if</strong> (_isAbstract_1) {
<a class="jxr_linenumber" name="L238" href="#L238">238</a>         _or_1 = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L239" href="#L239">239</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L240" href="#L240">240</a>         Element _owner_2 = operation.getOwner();
<a class="jxr_linenumber" name="L241" href="#L241">241</a>         _or_1 = (_owner_2 instanceof Enumeration);
<a class="jxr_linenumber" name="L242" href="#L242">242</a>       }
<a class="jxr_linenumber" name="L243" href="#L243">243</a>       _and = _or_1;
<a class="jxr_linenumber" name="L244" href="#L244">244</a>     }
<a class="jxr_linenumber" name="L245" href="#L245">245</a>     <strong class="jxr_keyword">if</strong> (_and) {
<a class="jxr_linenumber" name="L246" href="#L246">246</a>       _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L247" href="#L247">247</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L248" href="#L248">248</a>       Interface _<strong class="jxr_keyword">interface</strong> = operation.getInterface();
<a class="jxr_linenumber" name="L249" href="#L249">249</a>       <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(_<strong class="jxr_keyword">interface</strong>, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L250" href="#L250">250</a>       _or = _notEquals;
<a class="jxr_linenumber" name="L251" href="#L251">251</a>     }
<a class="jxr_linenumber" name="L252" href="#L252">252</a>     <strong class="jxr_keyword">return</strong> _or;
<a class="jxr_linenumber" name="L253" href="#L253">253</a>   }
<a class="jxr_linenumber" name="L254" href="#L254">254</a>   
<a class="jxr_linenumber" name="L255" href="#L255">255</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> isDefault(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L256" href="#L256">256</a>     <strong class="jxr_keyword">boolean</strong> _and = false;
<a class="jxr_linenumber" name="L257" href="#L257">257</a>     Interface _<strong class="jxr_keyword">interface</strong> = operation.getInterface();
<a class="jxr_linenumber" name="L258" href="#L258">258</a>     <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(_<strong class="jxr_keyword">interface</strong>, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L259" href="#L259">259</a>     <strong class="jxr_keyword">if</strong> (!_notEquals) {
<a class="jxr_linenumber" name="L260" href="#L260">260</a>       _and = false;
<a class="jxr_linenumber" name="L261" href="#L261">261</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L262" href="#L262">262</a>       Default _stereotypeApplication = UMLUtil.&lt;Default&gt;getStereotypeApplication(operation, Default.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L263" href="#L263">263</a>       <strong class="jxr_keyword">boolean</strong> _notEquals_1 = (!Objects.equal(_stereotypeApplication, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L264" href="#L264">264</a>       _and = _notEquals_1;
<a class="jxr_linenumber" name="L265" href="#L265">265</a>     }
<a class="jxr_linenumber" name="L266" href="#L266">266</a>     <strong class="jxr_keyword">return</strong> _and;
<a class="jxr_linenumber" name="L267" href="#L267">267</a>   }
<a class="jxr_linenumber" name="L268" href="#L268">268</a>   
<a class="jxr_linenumber" name="L269" href="#L269">269</a>   <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> mustGenerateBody(<strong class="jxr_keyword">final</strong> Operation operation) {
<a class="jxr_linenumber" name="L270" href="#L270">270</a>     <strong class="jxr_keyword">boolean</strong> _isAbstract = JavaOperations.isAbstract(operation);
<a class="jxr_linenumber" name="L271" href="#L271">271</a>     <strong class="jxr_keyword">boolean</strong> _not = (!_isAbstract);
<a class="jxr_linenumber" name="L272" href="#L272">272</a>     <strong class="jxr_keyword">if</strong> (_not) {
<a class="jxr_linenumber" name="L273" href="#L273">273</a>       Native _stereotypeApplication = UMLUtil.&lt;Native&gt;getStereotypeApplication(operation, Native.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L274" href="#L274">274</a>       <strong class="jxr_keyword">return</strong> Objects.equal(_stereotypeApplication, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L275" href="#L275">275</a>     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L276" href="#L276">276</a>       Interface _<strong class="jxr_keyword">interface</strong> = operation.getInterface();
<a class="jxr_linenumber" name="L277" href="#L277">277</a>       <strong class="jxr_keyword">boolean</strong> _equals = Objects.equal(_<strong class="jxr_keyword">interface</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L278" href="#L278">278</a>       <strong class="jxr_keyword">if</strong> (_equals) {
<a class="jxr_linenumber" name="L279" href="#L279">279</a>         <strong class="jxr_keyword">boolean</strong> _isStatic = operation.isStatic();
<a class="jxr_linenumber" name="L280" href="#L280">280</a>         <strong class="jxr_keyword">if</strong> (_isStatic) {
<a class="jxr_linenumber" name="L281" href="#L281">281</a>           Native _stereotypeApplication_1 = UMLUtil.&lt;Native&gt;getStereotypeApplication(operation, Native.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L282" href="#L282">282</a>           <strong class="jxr_keyword">return</strong> Objects.equal(_stereotypeApplication_1, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L283" href="#L283">283</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L284" href="#L284">284</a>           <strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L285" href="#L285">285</a>         }
<a class="jxr_linenumber" name="L286" href="#L286">286</a>       } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L287" href="#L287">287</a>         Interface _<strong class="jxr_keyword">interface</strong>_1 = operation.getInterface();
<a class="jxr_linenumber" name="L288" href="#L288">288</a>         <strong class="jxr_keyword">boolean</strong> _notEquals = (!Objects.equal(_<strong class="jxr_keyword">interface</strong>_1, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L289" href="#L289">289</a>         <strong class="jxr_keyword">if</strong> (_notEquals) {
<a class="jxr_linenumber" name="L290" href="#L290">290</a>           <strong class="jxr_keyword">boolean</strong> _or = false;
<a class="jxr_linenumber" name="L291" href="#L291">291</a>           <strong class="jxr_keyword">boolean</strong> _isStatic_1 = operation.isStatic();
<a class="jxr_linenumber" name="L292" href="#L292">292</a>           <strong class="jxr_keyword">if</strong> (_isStatic_1) {
<a class="jxr_linenumber" name="L293" href="#L293">293</a>             _or = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L294" href="#L294">294</a>           } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L295" href="#L295">295</a>             Default _stereotypeApplication_2 = UMLUtil.&lt;Default&gt;getStereotypeApplication(operation, Default.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L296" href="#L296">296</a>             <strong class="jxr_keyword">boolean</strong> _notEquals_1 = (!Objects.equal(_stereotypeApplication_2, <strong class="jxr_keyword">null</strong>));
<a class="jxr_linenumber" name="L297" href="#L297">297</a>             _or = _notEquals_1;
<a class="jxr_linenumber" name="L298" href="#L298">298</a>           }
<a class="jxr_linenumber" name="L299" href="#L299">299</a>           <strong class="jxr_keyword">return</strong> _or;
<a class="jxr_linenumber" name="L300" href="#L300">300</a>         }
<a class="jxr_linenumber" name="L301" href="#L301">301</a>       }
<a class="jxr_linenumber" name="L302" href="#L302">302</a>     }
<a class="jxr_linenumber" name="L303" href="#L303">303</a>     <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L304" href="#L304">304</a>   }
<a class="jxr_linenumber" name="L305" href="#L305">305</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
